/*
To do:

b versions of sounds

flies can escape

Web poison?

kill fly buzz when caught

Cutting takes time

Cleanup that you can't climb own web
Strand ID
  Always drop when spinning -- we get strand ID of main seg (but what if junction?)

Different speeds on different territories

Don't switch strands if not moving

Make O release if gripping with no butt web

Web ownership nubs (put ownership only on segments, not fragments?)
(Segments get two wetnesses?)


Some reason not to poop out a ton of web?


Higher Quality Web Tug

Nicer smack when you hit a web (based on velocity)

Collect no-longer-used web pieces

Break segments due to weight?

Reconcile node mass (currently 1) with intra-line mass.

Ensure that spin_start_handle gets nulled if a body that that
handle is connected to gets destroyed

Preserve string lengths when cut?

Strands decay if both anchors are in same safe zone (they will never
do anything!)

segment_id stuff is deprecated.... (?)

can't delete segments without checking for spiders who have pointers
to them, etc
*/

const float MY_FRAME_RATE = 60.0f;
#include "../../utils/misc/framerate.h"



#include "shared/core/first.h"

// windows crap
#define WIN32_LEAN_AND_MEAN
#define WIN32_EXTRA_LEAN
#include <windows.h>
#include <windowsx.h>

// system
#include <assert.h>
#define _USE_MATH_DEFINES
#include <math.h>

// gl stuff
#include <gl/gl.h>
#include "glutils.h"

// physics stuff
#include "shared/physics/2d/2d_body_hull.h"
#include "shared/physics/2d/rigid/2d_rigid_sim.h"
#include "shared/physics/2d/rigid/2d_rigid_drag_force.h"
#include "shared/physics/2d/rigid/2d_rigid_gravity_force.h"
#include "shared/physics/2d/rigid/2d_rigid_spring_force.h"
#include "shared/physics/2d/rigid/2d_rigid_control_force.h"
#include "shared/physics/2d/rigid/2d_rigid_pt2pt_constraint.h"

using namespace ajb;
using namespace Physics::D2;
using namespace Physics::D2::Rigid;

// misc
#include "utils.h"
#include <vector>
using namespace std;

// media lib
#include "music.h"
#include "zsound.h"
#include "bitmap.h"

#include <stdlib.h>  // For memcpy
#include "web_editor.h"
#include "example.h"

#include "shared/input/joystick.h"
#include "entities.h"
#include "settings.h"
#include "fonts.h"

// window/camera stuff
char const AppName[] = "Spider!";
int WindowWidth = 1024;
int WindowHeight = 768;
bool AppQuit = false;  // stuff this to kill yourself
float FOVY = 45.0f, ZNear = 0.1f, ZFar = 100.0f;  // whatever, we're 2D
float AspectRatio = float(WindowWidth)/float(WindowHeight); // updated in Resize
float CameraAngleRadians = 0.0, CameraX = 0.0, CameraY = 0.0, CameraZ = 10.0;
Vec2 WorldFromWindowCoords( Vec2 screen );
Vec2 WindowFromWorldCoords( Vec2 world );

GLuint bitmap_spider_spinning, bitmap_spider_clenching;
GLuint bitmap_background;
GLuint bitmap_timer_bar;
int timer_bar_width;
int timer_bar_height;

//Web_Strand *spider_motion_exited_strand;

// win32 stuff
HWND WindowHandle;
HDC WindowDC;

// gl stuff
HGLRC WindowRC;

// functions for you to play in
void Resize( int w, int h );
void Initialize( void );
void Uninitialize( void );
LONG FAR PASCAL AppWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam);
bool point_within_safe_region(Vec2 pos);
Web_Fragment *get_closest_fragment(Web_Segment *segment, Entity *e);
void tie_fragment_to_world(Web_Fragment *e1);
void update_motion_falling(Spider *spider);

void Update();

// system
Music music;

// physics stuff
Sim simulator;
Drag_Force    global_drag(.05f, .05f);	  //a little drag helps with stability
Gravity_Force gravity(Vec2(0.0f, -GRAVITY_MAGNITUDE));
Rigid_Body    world_body(make_Body_Null(),Vec2(0,0),0,0,0);


bool draw_control_lattice = false;
bool draw_web_fragment_nodes = false;
bool should_draw_safe_regions = false;
bool winner_chosen = false;
int the_winner = 0;

int next_segment_id = 1;

Auto_Array <Web_Segment *> web_segments;

const float Y_OUT_OF_BOUNDS = -6.0f;
const float Y_LOW = -5.0f;
const float Y_HIGH = +4.0f;
const float FLY_X_LEFT = -8.0f;
const float FLY_X_RIGHT = 8.0f;


float X0 = -7.41f;
float X1 = +7.41f;
float Y0 = -6.0f;
float Y1 = 5.57f;
float XPAD = 1.5f;
float YPAD = 1.3f;

const int NUM_PLAYERS = 2;
int player_scores[NUM_PLAYERS + 1];
Vec2 respawn_positions[NUM_PLAYERS + 1] = {
    Vec2(0.0f, 0.0f),
    Vec2(-3.0f, Y1 - YPAD * 0.5f),
    Vec2(+3.0f, Y1 - YPAD * 0.5f)
};

const float GS = 0.7f;
const float RS = 0.7f;
Vec3 team_colors[NUM_PLAYERS + 1] = {
    Vec3(0.4f, 0.4f, 0.4f),
    Vec3(0.68f*GS, 0.85f*GS, 0.68f*GS),
    Vec3(0.85f*RS, 0.6f*RS, 0.6f*RS)
};

Vec3 team_colors_wet[NUM_PLAYERS + 1] = {
    Vec3(0.85f, 0.85f, 0.85f),
    Vec3(0.15f, 0.9f, 0.15f),
    Vec3(0.9f, 0.15f, 0.15f)
};

char *team_names[NUM_PLAYERS + 1] = {
    "Neutral", "Green", "Red"
};


char *walk_animation_names_1[] = {
    "content/bitmaps/player_1_walk.1.tga",
    "content/bitmaps/player_1_walk.2.tga",
    "content/bitmaps/player_1_walk.3.tga",
    "content/bitmaps/player_1_walk.4.tga",
    "content/bitmaps/player_1_walk.5.tga",
    "content/bitmaps/player_1_walk.6.tga",
    "content/bitmaps/player_1_walk.7.tga",
    "content/bitmaps/player_1_walk.8.tga",
    "content/bitmaps/player_1_walk.9.tga",
    "content/bitmaps/player_1_walk.10.tga"
};

char *walk_animation_names_2[] = {
    "content/bitmaps/player_2_walk.1.tga",
    "content/bitmaps/player_2_walk.2.tga",
    "content/bitmaps/player_2_walk.3.tga",
    "content/bitmaps/player_2_walk.4.tga",
    "content/bitmaps/player_2_walk.5.tga",
    "content/bitmaps/player_2_walk.6.tga",
    "content/bitmaps/player_2_walk.7.tga",
    "content/bitmaps/player_2_walk.8.tga",
    "content/bitmaps/player_2_walk.9.tga",
    "content/bitmaps/player_2_walk.10.tga"
};

const int NUM_WALKING_ANIMATIONS = sizeof(walk_animation_names_1) / sizeof(char *);

struct Animation_Set {
    GLuint walk_bitmaps[NUM_WALKING_ANIMATIONS];
    GLuint clenching;
    GLuint falling;
};

Animation_Set animation_sets[NUM_PLAYERS+1];

char *fly_animation_names[] = {
    "content/bitmaps/fly_fly_01.tga",
    "content/bitmaps/fly_fly_02.tga",
    "content/bitmaps/fly_fly_03.tga",
    "content/bitmaps/fly_fly_02.tga"
};

const int NUM_FLY_ANIMATIONS = sizeof(fly_animation_names) / sizeof(char *);
GLuint fly_animations[NUM_FLY_ANIMATIONS];

GLuint fly_cocoon_bitmap;

Web_Fragment *add_web_fragment(Vec2 position, int player_number);

Joystick ps2controller;


struct Safe_Region {
    Vec2 x0;
    Vec2 x1;
};

Auto_Array <Safe_Region *> safe_regions;


int random_integer() {
    // rand() makes me feel so dirty...
    
    return rand();
}


float random_in_range(float low, float high) {
    unsigned int n = rand();
    float t = n / (float)(RAND_MAX);
    
    return low + t * (high - low);
}

#define RandomInRange(name) random_in_range(name##_MIN, name##_MAX)

struct Score_Note {
    char text[20];
    
    Vec2 position;
    Vec2 velocity;

    Vec3 color;

    float alpha;  
    float dalpha_dt;
};

Auto_Array <Score_Note *> score_notes;

Web_Segment::Web_Segment() {
    player_number = 0;
    fragment_a = NULL;
    fragment_b = NULL;
    segment_id = 0;
}

Entity::Entity() :
    rb(make_Body_Null(), Vec2(0, 0), 0) 
{
    player_number = 0;
}
    
void Entity::set_position(Vec2 position) {
    rb.x = position;
    rb.update_derived_state();
}

void Entity::set_mass(float mass) {
    rb.inv_m = 1.0f / mass;
    rb.update_derived_state();
}


Web_Fragment::Web_Fragment() {
    wetness = 0.0f;
    type = ENTITY_TYPE_WEB_FRAGMENT;
}

Spider::Spider(int _player_number) : Entity() {
    player_number = _player_number;
    speed = SPIDER_SPEED_FRIENDLY;

    tug_force = NULL;

    rb.set_body(make_Body_Sphere(SPIDER_RADIUS));
    set_mass(SPIDER_MASS);
    type = ENTITY_TYPE_SPIDER;
    rb.update_derived_state();

    spin_forces = false;
    clench_forces = false;

    spin_segment = NULL;
    walk_segment = NULL;

    respawn();
}

void no_spin_force(Spider *spider);
void no_clench_tie(Spider *spider);
Web_Fragment *terminate_spin_segment(Spider *);

float my_lerp(float v0, float v1, float t) {
    return v0 + t * (v1 - v0);
}


void Spider::respawn() {
    rb.v = Vec2(0, 0);
    rb.O = M_PI * 0.5f;
    set_position(respawn_positions[player_number]);
    motion_mode = MOTION_MODE_RESPAWNING;
    respawn_time = the_time;

    no_spin_force(this);
    no_clench_tie(this);
    Web_Fragment *node = terminate_spin_segment(this);
    if (node) node->player_number = player_number;

    wants_falling = false;
    wants_clenching = false;
    wants_spinning = false;
    wants_webstick = false;
}

Fly::Fly() : Entity() {
    // When a spider sticks up a fly, 
    player_number = 0;
    time_to_be_released = 0;
    type = ENTITY_TYPE_FLY;

    spawn_time = the_time;

    set_mass(FLY_MASS);

    web_tie = NULL;
    antigravity = NULL;

    simulator.add(rb);
}

    
Fly::~Fly() {
    if (web_tie) {
        simulator.remove(*web_tie);
        delete web_tie;
    }

    no_antigravity();

    simulator.remove(rb);
}

void Fly::no_antigravity() {
    if (antigravity) {
        simulator.remove(*antigravity);
        delete antigravity;
        antigravity = NULL;

        rb.inv_I = (3.0f * rb.inv_m) / (FLY_RADIUS * FLY_RADIUS);
    }
}

void Fly::yes_antigravity() {
    if (antigravity) return;
    antigravity = new Constant_Force(Handle(rb, Vec2(0, 0)));
    antigravity->m_f = Vec2(0, GRAVITY_MAGNITUDE * (1.0f / rb.inv_m));
    simulator.add(*antigravity);

    rb.inv_I = 0.0f;
    rb.w = 0.0f;
}

Auto_Array <Entity *> entities;

//vector<Entity*> objs;
Vec2 world_mouse, screen_mouse;


void clean_entities() {
    // XXXXX Fill me in!
}


void play_player_sound(char*name) {
    char buf[BUFSIZ];
    sprintf(buf, "content/sounds/%s.wav", name);
    zsoundPlay(buf);
}
    
GLuint load_gl_texture(char *name, int *width_return = NULL, int *height_return = NULL) {
    Bitmap_Load_Result result;
    verify(LoadBitmapByExtension(name, &result));

    // gl stuff
    GLuint texture = gl_texture_from_bitmap(result.data, result.width, result.height,
                                            result.bytes_per_pixel);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);

    if (width_return) *width_return = result.width;
    if (height_return) *height_return = result.height;

    // delete the bitmap
    delete [] result.data;

    return texture;
}

Vec2 world_space_to_body_space(Rigid_Body const &rb, Vec2 position_world) {
    Vec2 tmp = position_world - rb.x;
    Vec2 position_body = transpose_times(rb.R, tmp);
    return position_body;
}

Web_Segment *put_segment_between_fragments(Web_Fragment *e1, Web_Fragment *e2, int segment_id) {
    Vec2 delta = e2->rb.x - e1->rb.x;
    float rest_length = delta.len();
    float length = rest_length * SPRING_LENGTH_FACTOR;
    Web_Segment *segment = new Web_Segment();
    segment->fragment_a = e1;
    segment->fragment_b = e2;
    segment->force = Spring_Force(Handle(e1->rb, Vec2(0, 0)),
                                  Handle(e2->rb, Vec2(0, 0)),
                                  SPRING_KS, SPRING_KD, length);
    segment->segment_id = segment_id;
    web_segments.add(segment);
    simulator.add(segment->force);

    return segment;
}

void set_tug_force(Spider *spider, Handle const &handle, Vec2 const &vec) {
    if (!spider->tug_force) {
        spider->tug_force = new Constant_Force(handle);
        simulator.add(*spider->tug_force);
    }

    spider->tug_force->m_a = handle;
    spider->tug_force->m_f = vec;
}

void no_tug_force(Spider *spider) {
    if (spider->tug_force) {
        simulator.remove(*spider->tug_force);
        delete spider->tug_force;
        spider->tug_force = NULL;
    }
}

void update_spider_hang_force(Spider *spider) {
    float mass = 1.0f / spider->rb.inv_m;
    Vec2 mg = gravity.m_g * mass;
        
    Web_Segment *segment = spider->walk_segment;
    if (segment) {
        Web_Fragment *fragment = get_closest_fragment(segment, spider);
        Handle handle(fragment->rb,
                      world_space_to_body_space(fragment->rb, spider->rb.x));
        set_tug_force(spider, handle, mg);
    } else {
        no_tug_force(spider);
    }
}

void Web_Segment::get_endpoints(Vec2 *p0_ret, Vec2 *p1_ret) {
    Vec2 p0 = force.m_a.x_worldS();
    Vec2 p1 = force.m_b.x_worldS();

    *p0_ret = p0;
    *p1_ret = p1;
}

Vec2 Web_Segment::find_closest_point(Vec2 target, float *t_return) {
    Vec2 p0, p1;
    get_endpoints(&p0, &p1);

    Vec2 l = p1 - p0;
    Vec2 x = target - p0;

    float l_len = l.len();
    if (l_len == 0) return p0;  // Degenerate segment!
    Vec2 l_hat = l * (1.0f / l_len);

    float t = (x * l_hat) / l_len;   // The * is a dot product.
    if (t < 0) t = 0;
    if (t > 1) t = 1;
    
    Vec2 result = p0 + l * t;
    if (t_return) *t_return = t;
    return result;
}

float Web_Segment::get_wetness(float t) {
    float wet0 = 0.0f;
    float wet1 = 0.0f;

    if (fragment_a) wet0 = fragment_a->wetness;
    if (fragment_b) wet1 = fragment_b->wetness;
    
    return wet0 + t * (wet1 - wet0);
}

/*
    float s_len_l = x * l;  // This * is a dot product.
    float s_prime_len_l = s_len_l;
    float l_squared = l.len2();

    if (l_squared == 0) return p0;  // Degenerate segment!

//    if (s_prime_len_l < 0) s_prime_len_l = 0;
//    if (s_prime_len_l > l_squared) s_prime_len_l = l_squared;

    float t = s_prime_len_l / l_squared;
    return p0 + t * l;
*/


Vec2 find_nearest_strand_point(Vec2 position, float max_radius, Web_Segment **segment_result, float *t_result) {
    *segment_result = NULL;
    Vec2 position_result(0, 0);

    float best_dist = FLT_MAX;
    float best_t = 0;
    int i;
    for (i = 0; i < web_segments.items; i++) {
        Web_Segment *segment = web_segments[i];

        float t;
        Vec2 closest = segment->find_closest_point(position, &t);
        float dist = (closest - position).len();
        if (dist > max_radius) continue;
        if (dist < best_dist) {
            *segment_result = segment;
            best_dist = dist;
            best_t = t;
            position_result = closest;
        }            
    }

    if (t_result) *t_result = best_t;
    return position_result;
}

Vec2 find_nearest_strand_point(Spider *spider, float length_scale, Vec2 desired_pos, Web_Segment **segment_result, float *t_result) {
    *segment_result = NULL;
    Vec2 position_result(0, 0);

    float max_radius = length_scale;

    // If *segment_result ends up being NULL, it means we didn't find anything.

    float best_dist = FLT_MAX;
    float best_t = 0;

    int i;
    for (i = 0; i < web_segments.items; i++) {
        Web_Segment *segment = web_segments[i];

        // Can't walk on the segment we are spinning out...
        bool reject = false;
        int j;
        for (j = 0; j < spider->segments_i_cannot_climb.items; j++) {
            if (spider->segments_i_cannot_climb[j] == segment) reject = true;
        }

        if (reject) continue;

        float t;
        Vec2 closest = segment->find_closest_point(desired_pos, &t);
        float dist = (closest - desired_pos).len();
        if (dist > max_radius) continue;
        if (dist < best_dist) {
            *segment_result = segment;
            best_dist = dist;
            position_result = closest;
            best_t = t;
        }            
    }

    if (t_result) *t_result = best_t;
    return position_result;
}

Vec2 find_nearest_strand_point_with_lower_y(float length_scale, Vec2 desired_pos, Web_Segment **segment_result) {
    *segment_result = NULL;
    Vec2 position_result(0, 0);

    float max_radius = length_scale;

    // If *segment_result ends up being NULL, it means we didn't find anything.

    float best_dist = FLT_MAX;

    int i;
    for (i = 0; i < web_segments.items; i++) {
        Web_Segment *segment = web_segments[i];
        Vec2 closest = segment->find_closest_point(desired_pos);
        if (closest.y() >= desired_pos.y()) continue;

        float dist = (closest - desired_pos).len();
        if (dist > max_radius) continue;
        if (dist < best_dist) {
            *segment_result = segment;
            best_dist = dist;
            position_result = closest;
        }            
    }

    return position_result;
}

void cut_current_strand(Spider *spider) {
    if (!spider->walk_segment) return;
    
    int i;
    for (i = 0; i < web_segments.items; i++) {
        Web_Segment *segment = web_segments[i];
        if (segment == spider->walk_segment) {
            spider->walk_segment = NULL;
            // @Leak: clean up this segment properly!
            simulator.remove(segment->force);

            web_segments[i] = web_segments[web_segments.items - 1];
            web_segments.items--;
            break;
        }
    }

    play_player_sound("web_cut");
    spider->motion_mode = MOTION_MODE_FALLING;
}


float CLENCH_FORCE_SCALE = 35.0f;
float spider_spin_length_per_second = 0.75f;

void no_clench_tie(Spider *spider) {
    if (!spider->clench_forces) return;
    spider->clench_forces = false;

    simulator.remove(spider->clench_force);
    simulator.remove(spider->clench_tie);
}

void yes_spin_force(Spider *spider) {
    if (!spider->spin_segment) return;

    if (spider->spin_forces) return;
    spider->spin_forces = true;

    spider->spin_force = Constant_Force(Handle(spider->spin_segment->force.m_b.rb(), 
                                               Vec2::zero()));
    simulator.add(spider->spin_force);
}

void no_spin_force(Spider *spider) {
    if (!spider->spin_forces) return;
    spider->spin_forces = false;

    simulator.remove(spider->spin_force);
}

/*
void no_spin_tie() {
    if (spin_tie) {
        simulator.remove(*spin_force);
        delete spin_force;
        spin_force = NULL;

        delete spin_tie;
        simulator.remove(*spin_tie);
        spin_tie = NULL;
    }
}
*/

Handle spider_butt_handle(Entity *e) {
    Vec2 offset(-SPIDER_RADIUS * 0.95, 0);
    return Handle(e->rb, offset);
}

void start_new_spin_segment(Spider *spider, Handle handle, float length, int segment_id) {
    spider->spin_segment = new Web_Segment();
    spider->spin_segment->player_number = spider->player_number;
    spider->spin_segment->force = Spring_Force(handle,
                                               spider_butt_handle(spider),
                                               SPIN_SPRING_KS, SPIN_SPRING_KD, length);
    simulator.add(spider->spin_segment->force);
    web_segments.add(spider->spin_segment);

    yes_spin_force(spider);

    spider->segments_i_cannot_climb.add(spider->spin_segment);
}

void no_antigravity(Spider *spider) {
    // Antigravity
    spider->antigravity.m_f = Vec2(0, 0);
    spider->rb.inv_I = 1.0f / (0.333f * SPIDER_MASS * SPIDER_RADIUS * SPIDER_RADIUS);
}

void yes_antigravity(Spider *spider) {
    // Antigravity
    spider->antigravity.m_f = Vec2(0, GRAVITY_MAGNITUDE * (1.0f / spider->rb.inv_m));
    spider->rb.inv_I = 0.0f;
    spider->rb.w = 0.0f;
}

void update_motion_clenching(Spider *spider) {
    Web_Segment *segment = spider->walk_segment;
    if (!segment) return;

    no_antigravity(spider);

	if (!spider->clench_forces) {
        spider->clench_forces = true;
		spider->clench_force = Constant_Force(Handle(segment->force.m_a.rb(), Vec2::zero()));
		simulator.add(spider->clench_force);

        spider->clench_tie = Spring_Force(Handle(spider->rb, Vec2(0, 0)),
                                          Handle(segment->force.m_a.rb(), Vec2(0, 0)),
                                          SPRING_KS, SPRING_KD, 0);
        simulator.add(spider->clench_tie);
	}

    Vec2 p0, p1;
    segment->get_endpoints(&p0, &p1);
    
    Vec2 strand_dir = (p1 - p0).norm();
    Vec2 push = spider->LeftStick;

	spider->clench_force.m_f = push * CLENCH_FORCE_SCALE;    
}


void maybe_wet(Web_Fragment *fragment, Spider *spider) {
    if (!fragment) return;

    if ((fragment->player_number != 0) && (fragment->player_number != spider->player_number)) return;

    float dist = (spider->rb.x - fragment->rb.x).len();
    if (dist < SPIDER_RADIUS) {
        fragment->wetness = 1.0f;
    }

    return;
}

void update_motion_walking(Spider *spider) {
    // Move the spider...
    float length_scale = the_dt * spider->speed;  // @Niceness: Speed takes effect one frame late?!?


    // Kill any velocity he had from falling, etc
    spider->rb.v = Vec2(0, 0);

    Vec2 desired_pos;
    //
    // vertical_only and horizontal_only help us to glide along the
    // borders...
    //
    Vec2 vertical_only, horizontal_only;


    desired_pos = spider->rb.x;
    horizontal_only = spider->rb.x;
    vertical_only = spider->rb.x;

    bool intentionally_aiming = false;
    float len = spider->LeftStick.len();
    if (len > JOYSTICK_LEN_TO_MOVE) {
        intentionally_aiming = true;
        Vec2 delta = length_scale * spider->LeftStick;
        desired_pos = spider->rb.x + delta;

        Vec2 deltax(delta.x(), 0);
        Vec2 deltay(0, delta.y());

        horizontal_only = spider->rb.x + deltax;
        vertical_only = spider->rb.x + deltay;
    }

    float scale_extra;
    if (spider->walk_segment) {
        scale_extra = 50.0f;
    } else {
        scale_extra = 5.0f;
    }

    Web_Segment *segment = NULL;
    float t;
    Vec2 nearest_strand_point = find_nearest_strand_point(spider, length_scale * scale_extra, desired_pos, &segment, &t);


    Vec2 new_position;
    bool got_new_position = false;

    if (point_within_safe_region(desired_pos)) {
        spider->walk_segment = NULL;
        got_new_position = true;
        new_position = desired_pos;
        spider->speed = SPIDER_SPEED_FRIENDLY;
    } else if (segment) {
        // @Robustness: Do a better job of this!  Test each endpoint for
        // distance or whatever.
        maybe_wet(segment->fragment_a, spider);
        maybe_wet(segment->fragment_b, spider);

        float wetness = segment->get_wetness(t);
        float speed;
        if ((segment->player_number == spider->player_number) ||
            (segment->player_number == 0)) {
            speed = SPIDER_SPEED_FRIENDLY;
        } else {
            speed = my_lerp(SPIDER_SPEED_ENEMY, SPIDER_SPEED_ENEMY_WET, wetness);
        }

        spider->speed = speed;
        spider->walk_segment = segment;

        new_position = nearest_strand_point;
        got_new_position = true;
    } else if (point_within_safe_region(vertical_only)) {
        spider->walk_segment = NULL;
        got_new_position = true;
        new_position = vertical_only;
        spider->speed = SPIDER_SPEED_FRIENDLY;
    } else if (point_within_safe_region(horizontal_only)) {
        spider->walk_segment = NULL;
        got_new_position = true;
        new_position = horizontal_only;
        spider->speed = SPIDER_SPEED_FRIENDLY;
    } else {
        spider->speed = SPIDER_SPEED_FRIENDLY;
        // We must fall (maybe we were dragged into the open...)
        if (!point_within_safe_region(spider->rb.x)) {
            spider->motion_mode = MOTION_MODE_FALLING;
            update_motion_falling(spider);
            return;
        }
    }


    if (got_new_position) {
        if (intentionally_aiming) {
            // Update spider theta
            Vec2 delta = new_position - spider->rb.x;
            if (delta.len() > DELTA_LEN_TO_AIM_SPIDER) {
                float spider_theta = atan2(delta.y(), delta.x());
                spider->rb.O = spider_theta;
                spider->rb.update_derived_state();
            }
        }

        spider->set_position(new_position);
    }

    update_spider_hang_force(spider);
    yes_antigravity(spider);
}

void update_motion_falling(Spider *spider) {
    no_antigravity(spider);
    no_tug_force(spider);

    //
    // Swing if we can...
    //
    if (spider->spin_segment) {
        Web_Segment *segment = spider->spin_segment;

        Vec2 p0, p1;
        segment->get_endpoints(&p0, &p1);
    
        Vec2 strand_dir = (p1 - p0).norm();
        Vec2 push = spider->LeftStick;

        spider->spin_force.m_f = push * CLENCH_FORCE_SCALE;
    } else {
        no_spin_force(spider);
    }



    //
    // See if we catch something...
    //
    if (!spider->wants_falling) {

        Vec2 desired_pos = spider->rb.x;
        float length_scale = SPIDER_RADIUS * 0.7f;
        Web_Segment *segment = NULL;
        Vec2 landing_point = find_nearest_strand_point_with_lower_y(length_scale, desired_pos, &segment);
        bool do_walk = false;

        if (segment) {
            do_walk = true;
        }

        if (point_within_safe_region(desired_pos)) {
            do_walk = true;
            landing_point = desired_pos;
            segment = NULL;
        }

        if (do_walk) {
            spider->motion_mode  = MOTION_MODE_WALKING;
            spider->rb.x = landing_point;

            Vec2 saved_velocity = spider->rb.x;
            float mass = 1.0f / (spider->rb.inv_m);
            Vec2 impulse = saved_velocity * mass;

            if (segment) play_player_sound("spider_fall");
            update_motion_walking(spider);
        }

/*
            if (spider->walk_segment) {
                // @Segment
                Spring_Force *force = spider->walk_segment->force;
                Entity *make_spider_entity();
                Entity *dummy = make_spider_entity();
                Spring_Force *tie = new Spring_Force(Handle(dummy->rb, Vec2(0, 0)),
                                                     Handle(force->m_a.rb(), Vec2(0, 0)),
                                                     SPRING_KS, SPRING_KD, 0);
                simulator.add(dummy->rb);
                simulator.add(*tie);
*/
/*
                Spring_Force *force = spider->walk_segment->force;
                force->m_a.rb().apply_impulse_at(impulse, Vec2(0, 0));
            }
*/
    }

}


Web_Fragment *terminate_spin_segment(Spider *spider) {
    Web_Segment *segment = spider->spin_segment;
    if (!segment) return NULL;

    Web_Fragment *e = add_web_fragment(spider->rb.x, spider->player_number);
    e->wetness = 1.0f;

    // Tie the last segment off onto this entity, and then start a new one...
    Handle handle(e->rb, Vec2(0, 0));
    segment->force.m_b = handle;
    segment->fragment_b = e;
    spider->spin_segment = NULL;

    return e;
}

void update_spin_action(Spider *spider) {
    if (!spider->spin_segment) {
        spider->segments_i_cannot_climb.reset();
        return;
    }

    //
    // Extend web if need be...
    //

    float length = spider_spin_length_per_second * the_dt;
    if (spider->wants_spinning) {
        float new_len = spider->spin_segment->force.m_rest_len + length;
        if (new_len > LENGTH_PER_TESS) {
            spider->spin_segment->force.m_rest_len = LENGTH_PER_TESS;
            int segment_id = spider->spin_segment->segment_id;  // Because we are about to set spin_Segment to NULL in the call to terminate_spin_segment(), so we save this value.
            Web_Fragment *e = terminate_spin_segment(spider);
            start_new_spin_segment(spider, Handle(e->rb, Vec2(0, 0)), 0.0f, segment_id);
            spider->spin_segment->fragment_a = e;
            new_len -= LENGTH_PER_TESS;
        }

        spider->spin_segment->force.m_rest_len = new_len;
    }
}

Web_Fragment *get_closest_fragment(Web_Segment *segment, Entity *e) {
    // @Refactor: I think it's impossible now to have NULL fragments?
    // But it's too close to final check-in time so I am playing it safe.
    if (segment->fragment_a == NULL) {
        assert(segment->fragment_b);
        return segment->fragment_b;
    }

    if (segment->fragment_b == NULL) return segment->fragment_a;

    float dist1 = (e->rb.x - segment->fragment_a->rb.x).len();
    float dist2 = (e->rb.x - segment->fragment_b->rb.x).len();

    if (dist1 < dist2) return segment->fragment_a;
    return segment->fragment_b;
}

void Fly::update() {
    float delta = the_time - spawn_time;

    switch (motion_mode) {
    case FLY_FLYING: {

        // Do my sine wave cruising thing.
        float y1 = amplitude1 * cos((delta / period1) * 2 * M_PI);
        float y2 = amplitude2 * cos((delta / period2) * 2 * M_PI);

        rb.x = Vec2(rb.x.x(), y1 + y2 + spawn_position.y());
        
        // Set theta...
        float x_unit = 1.0f;
        if (rb.v.x() < 0.0f) x_unit = -1.0f;
        rb.O = atan2(y1, x_unit);


        rb.update_derived_state();


        // See if we get stuck.
        Web_Segment *segment;
        float t;
        Vec2 pos = find_nearest_strand_point(rb.x, FLY_RADIUS, &segment, &t);
        if (segment) {
            float wetness = segment->get_wetness(t);
            float pps = my_lerp(FLY_STICK_PROBABILITY_PER_SECOND_DRY,
                                FLY_STICK_PROBABILITY_PER_SECOND_WET,
                                wetness);
            
            float prob = pps * the_dt;
            float roll = random_in_range(0, 1);
            if (roll <= prob) {
                zsoundPlay("content/sounds/fly_stuck_2.wav");

                motion_mode = FLY_STUCK;
                // @Niceness: Impact the web.
                rb.v = Vec2(0, 0);
                rb.update_derived_state();
                time_to_be_released = the_time + RandomInRange(FLY_STRUGGLING_TIME);

                Web_Fragment *fragment = get_closest_fragment(segment, this);
                Handle handle(fragment->rb, Vec2(0, 0));
                web_tie = new Spring_Force(handle, Handle(rb, Vec2(0, 0)),
                                           FLY_SPRING_KS, FLY_SPRING_KD, 0);
                simulator.add(*web_tie);
            }
        }
        break;
    }
    case FLY_STUCK:
        no_antigravity();
        break;
    case FLY_STEWING:
        no_antigravity();
        if (the_time > stew_time_end) {
            motion_mode = FLY_DONE;
        }
        break;
    case FLY_DONE:
        no_antigravity();
        break;
    default:
        assert(0);
        break;
    } 
}

Fly *find_very_close_fly(Spider *spider, int motion_mode) {
    Vec2 pos = spider->rb.x;

    int i;
    for (i = 0; i < entities.items; i++) {
        Entity *e = entities[i];
        if (e->type == ENTITY_TYPE_FLY) {
            Fly *fly = static_cast <Fly *>(e);
            if (fly->motion_mode != motion_mode) continue;

            float dist = (pos - fly->rb.x).len();
            if (dist < SPIDER_RADIUS_TO_TOUCH_FLY) {
                return fly;
            }
        }
    }

    return NULL;
}

Fly *find_very_close_cocooned_fly(Spider *spider) {
    Vec2 pos = spider->rb.x;

    int i;
    for (i = 0; i < entities.items; i++) {
        Entity *e = entities[i];
        if (e->type == ENTITY_TYPE_FLY) {
            Fly *fly = static_cast <Fly *>(e);
            if (fly->motion_mode == FLY_FLYING) continue;

            float dist = (pos - fly->rb.x).len();
            if (dist < SPIDER_RADIUS_TO_TOUCH_FLY) {
                return fly;
            }
        }
    }

    return NULL;
}

        
Score_Note *add_score(Spider *spider, Vec2 position, int points, float y_multiplier = 1.0f) {
    if ((spider->player_number != 1) && (spider->player_number != 2)) return NULL;

    if (!winner_chosen) {
        player_scores[spider->player_number] += points;
    }

    Score_Note *note = new Score_Note();
    if (points > 0) {
        sprintf(note->text, "+%d", points);
    } else {
        sprintf(note->text, "%d", points);
    }
    
    Vec2 screen = WindowFromWorldCoords(position);
    float x = screen.x();
    float y = WindowHeight - screen.y();

    // @HackTextConstant
    float offset = -0.25f * GetTextWidth(&small_font, note->text);
    x += offset;

    note->position = Vec2(x / WindowWidth, y / WindowHeight);
    note->velocity = Vec2(0, 0.15 * y_multiplier);

    note->color = team_colors_wet[spider->player_number];
    note->alpha = 1.0f;
    note->dalpha_dt = -0.5f;

    score_notes.add(note);
    return note;
}

void Spider::update() {
    int stick_index = player_number - 1;
	LeftStick = ps2controller.left_stick(stick_index);
	RightStick = ps2controller.right_stick(stick_index);


    rb.v *= 0.99f;
    rb.update_derived_state();

    // Compute dt
    static double last_time = 0;
    double now = GetTime();
    if (last_time == 0) {
        last_time = now;
        return;
    }

    // Handle control input stuff...

    wants_falling = false;
    wants_clenching = false;
    wants_spinning = false;
    wants_webstick = false;
    
    if (ps2controller.button_is_down(Joystick::BUTTON_RIGHT_D, stick_index)) {
        wants_falling = true;
    }

    if (ps2controller.button_went_down(Joystick::BUTTON_RIGHT_U, stick_index)) {
        cut_current_strand(this);
    }
    
    if (ps2controller.button_is_down(Joystick::BUTTON_SHOULDER_L2, stick_index)) {
        wants_clenching = true;
    }

    if (ps2controller.button_is_down(Joystick::BUTTON_SHOULDER_R1, stick_index)) {
        wants_spinning = true;
    }

    if (ps2controller.button_is_down(Joystick::BUTTON_RIGHT_R, stick_index)) {
        wants_webstick = true;
    }


    // Switch motion modes
    switch (motion_mode) {
    case MOTION_MODE_WALKING: {
        Fly *fly = find_very_close_fly(this, FLY_STUCK);
        if (fly) {
            fly->motion_mode = FLY_STEWING;
            fly->player_number = player_number;
            fly->stew_time_begin = the_time;
            fly->stew_time_end = the_time + FLY_STEWING_TIME;
            play_player_sound("fly_cacoon");
            add_score(this, fly->rb.x, 1);
        }

        fly = find_very_close_fly(this, FLY_DONE);
        if (fly) {
            play_player_sound("spider_eat_2");
            add_score(this, fly->rb.x, 3);
            delete fly;
            entities.remove(fly);
        }

        if (wants_falling) {
            Vec2 fall_direction(0, -1);
            Vec2 impulse = fall_direction * SPIDER_JUMP_SPEED * (1.0f / rb.inv_m);
            rb.apply_impulse_at(impulse, Vec2(0, 0));
            motion_mode = MOTION_MODE_FALLING;
            walk_segment = NULL;
//            play_player_sound("spider_fall");
        } else if (wants_clenching) {
            motion_mode = MOTION_MODE_CLENCHING;
        } else if (wants_spinning) {
            if (!spin_segment) {
                // We start a new spin... either connected to a graph node,
                // or from the free zone...

                Web_Fragment *fragment = NULL;
                int segment_id;
                if (walk_segment) {
                    fragment = get_closest_fragment(walk_segment, this);
                    segment_id = walk_segment->segment_id;
                } else if (point_within_safe_region(rb.x)) {
                    fragment = add_web_fragment(rb.x, player_number);
                    if (fragment) {
                        tie_fragment_to_world(fragment);
                        segment_id = next_segment_id++;
                    }
                }

                if (fragment) {
                    Handle handle(fragment->rb, Vec2(0, 0));
                    start_new_spin_segment(this, handle, LENGTH_PER_TESS * 0.95f, segment_id);
                    spin_segment->fragment_a = fragment;
                    play_player_sound("spin_out_web");
                }
            }
        }

        if (spin_segment && wants_webstick) {
            Web_Fragment *fragment = NULL;
            if (walk_segment) {
                fragment = get_closest_fragment(walk_segment, this);
            } else if (point_within_safe_region(rb.x)) {
                fragment = add_web_fragment(rb.x, player_number);
                if (fragment) tie_fragment_to_world(fragment);
            }

            if (fragment) {
                spin_segment->force.m_b = Handle(fragment->rb, Vec2(0, 0));
                spin_segment = NULL;
                play_player_sound("attach_web");
            }
        }

        break;
    }
    case MOTION_MODE_FALLING:
        if (spin_segment && wants_webstick) {
            rb.v *= 2.0f;
            terminate_spin_segment(this);
        }

        break;
    case MOTION_MODE_CLENCHING:
        if (!wants_clenching) {
            motion_mode = MOTION_MODE_WALKING;
        } else if (wants_falling) {
            rb.v *= 2.0f;
            motion_mode = MOTION_MODE_FALLING;
        }
        break;
    case MOTION_MODE_RESPAWNING:
        float delta = the_time - respawn_time;
        if (delta > RESPAWN_TIME_TOTAL) {
            motion_mode = MOTION_MODE_FALLING;
        }
        break;
    }

    update_spin_action(this);

    if (motion_mode != MOTION_MODE_CLENCHING) no_clench_tie(this);

    // Eval motion procs
    switch (motion_mode) {
    case MOTION_MODE_WALKING:
        update_motion_walking(this);
        break;
    case MOTION_MODE_FALLING:
        update_motion_falling(this);
        break;
    case MOTION_MODE_CLENCHING:
        update_motion_clenching(this);
        break;
    case MOTION_MODE_RESPAWNING:
        yes_antigravity(this);
        break;
    }
}


Spider *init_spider(int player_number) {
    Spider *spider = new Spider(player_number);

    entities.add(spider);
    simulator.add(spider->rb);

    spider->antigravity = Constant_Force(Handle(spider->rb, Vec2(0, 0)));
    simulator.add(spider->antigravity);

    spider->respawn();

    return spider;
}


Web_Fragment *add_web_fragment(Vec2 position, int player_number) {
    Web_Fragment *entity = new Web_Fragment();
    entity->rb.set_body(make_Body_Null());
    entity->set_position(position);
    entity->player_number = player_number;
    entities.add(entity);

    simulator.add(entity->rb);
    entity->rb.inv_I = 0;
    entity->rb.update_derived_state();

    return entity;
}

void tie_fragment_to_world(Web_Fragment *e1) {
    int player_number = 0;  // @PlayerNumber
//    Web_Fragment *world_tied = add_web_fragment(e1->rb.x, 0);
    Web_Fragment *world_tied = e1;
    Pt2Pt_Constraint *constraint = new Pt2Pt_Constraint(Handle(world_tied->rb, Vec2(0, 0)),
                                                        Handle(world_body, e1->rb.x));
    simulator.add(*constraint);
    // XXXXXXXXXXXX Save constraint!!!  So we can delete this guy.
/*
    Web_Segment *segment = new Web_Segment();
    segment->fragment_a = e1;
    segment->fragment_b = world_tied;
    segment->force = Spring_Force(Handle(e1->rb, Vec2(0, 0)),
//                                  Handle(world_body, e1->rb.x),
                                  Handle(world_tied->rb, Vec2(0, 0)),
                                  SPRING_KS, SPRING_KD, 0.0f);
    web_segments.add(segment);
    simulator.add(segment->force);
*/
}


void build_entities_from_web() {
    clean_entities();
    
    // Build nodes for all the endpoints

    Auto_Array <Web_Fragment *> anchor_entities;

    int i;
    for (i = 0; i < web_anchors.items; i++) {
        Web_Anchor *anchor = web_anchors[i];
        Web_Fragment *entity = add_web_fragment(anchor->position, 0);
        anchor_entities.add(entity);

        // @Refactor: Umm, this flag came out backwards?!?
        if (!anchor->tied_to_background) tie_fragment_to_world(entity);
    }

    // Interpolate the segments...

    for (i = 0; i < web_strands.items; i++) {
        int segment_id = next_segment_id++;

        Web_Strand *strand = web_strands[i];

        Vec2 pos0 = strand->anchor0->position;
        Vec2 pos1 = strand->anchor1->position;

        float len = (pos1 - pos0).len();
        float tess = floor(len * TESS_PER_UNIT_LENGTH + 0.5f);
        if (tess < 1.0f) tess = 1.0f;
        int itess = (int)tess;

        Vec2 delta = (pos1 - pos0) * (1.0f / tess);
        
        float mass_total = delta.len() * MASS_PER_UNIT_LENGTH;
        float mass_per_body = mass_total / (tess - 1);

        Vec2 cursor = pos0;

        int player_number = 0;
        Web_Fragment *previous = anchor_entities[strand->anchor0->index];
        int j;
        for (j = 0; j < itess - 1; j++) {
            cursor += delta;
            Web_Fragment *entity = add_web_fragment(cursor, player_number);
            entity->set_mass(mass_per_body);

            Web_Segment *segment = put_segment_between_fragments(previous, entity, segment_id);

            previous = entity;
        }

        Web_Fragment *final = anchor_entities[strand->anchor1->index];
        put_segment_between_fragments(previous, final, segment_id);
    }

    Spider *spider;
    spider = init_spider(1);
    spider = init_spider(2);
}

void left_button_down() {
    int index = get_anchor();
    if (index == -1) return;
    select_anchor(index);
}

void right_button_down() {
    bool shifted = 0x8000 & GetKeyState(VK_SHIFT);

    int index;

    if (shifted) {
        add_anchor(world_mouse, ANCHOR_RADIUS);
        index = web_anchors.items - 1;
    } else {
        index = get_anchor();
        if (index == -1) return;
    }

    connect_to_selected(index);
    select_anchor(index);
}

void handle_keydown(int key) {
    bool shifted = 0x8000 & GetKeyState(VK_SHIFT);

    switch (key) {
    case ' ':
        add_anchor(world_mouse, 0.1f);
        if (shifted) {
            connect_to_selected(web_anchors.items - 1);
            select_anchor(web_anchors.items - 1);
        }
        break;
    case 'P':
        save_web();
        break;
    case 'T':
        if (selected_anchor != -1) {
            Web_Anchor *anchor = web_anchors[selected_anchor];
            anchor->tied_to_background = !anchor->tied_to_background;
        }

        break;
    case 'B':
        build_entities_from_web();
        break;
    }
}

void add_safe_region(float x0, float y0, float x1, float y1) {
    Safe_Region *region = new Safe_Region;
    region->x0 = Vec2(x0, y0);
    region->x1 = Vec2(x1, y1);
    safe_regions.add(region);
}

/******************************** Initialize ********************************/
/* the window and graphics subsystem are set up but still hidden            */
void Initialize( void )
{
    GetTime(); // throw away initial 0.0 so we're seconds-from-startup


    add_safe_region(X0, Y0, X0 + XPAD, Y1);
    add_safe_region(X1 - XPAD, Y0, X1, Y1);
    add_safe_region(X0, Y1 - YPAD, X1, Y1);


    ps2controller.init();

    // gl stuff
    glClearColor(0.3f,0.4f,0.7f,0.0f);
    glEnable(GL_CULL_FACE);
    glEnable(GL_NORMALIZE);
    glEnable(GL_DEPTH_TEST);
    glShadeModel(GL_SMOOTH);

    int i;
    for (i = 0; i < NUM_WALKING_ANIMATIONS; i++) {
        animation_sets[1].walk_bitmaps[i] = load_gl_texture(walk_animation_names_1[i]);
        animation_sets[2].walk_bitmaps[i] = load_gl_texture(walk_animation_names_2[i]);
    }

    animation_sets[1].clenching = load_gl_texture("content/bitmaps/player_1_walk.6.tga");
    animation_sets[2].clenching = load_gl_texture("content/bitmaps/player_2_walk.6.tga");

    animation_sets[1].falling = load_gl_texture("content/bitmaps/player_1_walk.1.tga");
    animation_sets[2].falling = load_gl_texture("content/bitmaps/player_2_walk.1.tga");

    for (i = 0; i < NUM_FLY_ANIMATIONS; i++) {
        fly_animations[i] = load_gl_texture(fly_animation_names[i]);
    }

    fly_cocoon_bitmap = load_gl_texture("content/bitmaps/fly_cocoon.tga");
    bitmap_background = load_gl_texture("content/bitmaps/background.jpg");
    bitmap_timer_bar = load_gl_texture("content/bitmaps/timerbar.psd", &timer_bar_width, &timer_bar_height);

    InitializeFrameRate(MY_FRAME_RATE);

    // init our view
    Resize(WindowWidth,WindowHeight);

    // music init
    music.init();
    music.set_subdirectory("content/music/");
    music.setupnotes();
    music.loadseg("atmosphere", "atmosphere.sgt", MUSIC_TRACK_MAIN);

    // sound init
    zsoundInit(WindowHandle);


    load_web();
    build_entities_from_web();


    // Really start playing the music.

    music.play("atmosphere");
    zsoundPlay("content/sounds/start.wav");

    // initialize the physics
    simulator.add(global_drag);
    simulator.add(gravity);
    simulator.add(world_body);
}

void draw_point(Vec2 position) {
    glBegin(GL_POINTS);
    glVertex2f(position.x(), position.y());
    glEnd();
}

void draw_control_lattice_stuff() {
    // draw mouse
    glPointSize(16.0);
    glColor3f(0, 0, 0.7);
    draw_point(world_mouse);

    
    int i;
    for (i = 0; i < web_anchors.items; i++) {
        Web_Anchor *anchor = web_anchors[i];
        if (anchor->tied_to_background) {
            glPointSize(4.0);
            glColor3f(1, 1, 0);
        } else {
            glPointSize(7.0);
            glColor3f(1, 1, 0.4);
        }

        draw_point(anchor->position);
    }

    if (selected_anchor != -1) {
        glPointSize(10.0);
        glColor3f(0, 1, 0);
        draw_point(web_anchors[selected_anchor]->position);
    }

    // Draw all the web strands.
    glColor3f(1.0f, 0.4f, 0.4f);

    glBegin(GL_LINES);
    for (i = 0; i < web_strands.items; i++) {
        Web_Strand *strand = web_strands[i];
        glVertex2fv(strand->anchor0->position.m_v);
        glVertex2fv(strand->anchor1->position.m_v);
    }
    glEnd();

}

int get_frame_index(float offset = 0.0f) {
    float fframe = (the_time + offset) * 30.0f;
    return (int)floor(fframe);
}

Vec3 get_wetness_color(int player_number, Web_Fragment *fragment) {
    Vec3 base_color = team_colors[player_number];
    Vec3 wet_color = team_colors_wet[player_number];

    float wetness = 0.0f;
    if (fragment) wetness = fragment->wetness;

    Vec3 result = base_color + wetness * (wet_color - base_color);
    return result;
}

void draw_entity_quad(Entity *e, float radius) {
    float s = radius;

    Vec2 e1 = e->rb.R * Vec2(s, 0);
    Vec2 e2 = e->rb.R * Vec2(0, s);
    Vec2 p = e->rb.x;

    glEnable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);


    glBegin(GL_QUADS);
    glTexCoord2f(0, 0);
    glVertex2fv((p - e1 - e2).m_v);
    glTexCoord2f(1, 0);
    glVertex2fv((p + e1 - e2).m_v);
    glTexCoord2f(1, 1);
    glVertex2fv((p + e1 + e2).m_v);
    glTexCoord2f(0, 1);
    glVertex2fv((p - e1 + e2).m_v);
    glEnd();

    glDisable(GL_TEXTURE_2D);
    glDisable(GL_BLEND);
}
            
void draw_fly_timer(Fly *fly) {
    Vec2 bar_middle = fly->rb.x + Vec2(0, -FLY_RADIUS);
    float bar_width = FLY_RADIUS * 1.8;
    float bar_height = FLY_RADIUS * 0.3;

    Vec2 p0, p1, p2, p3;
    p0 = bar_middle + Vec2(-bar_width * 0.5, -bar_height * 0.5);
    p1 = bar_middle + Vec2(+bar_width * 0.5, -bar_height * 0.5);
    p2 = bar_middle + Vec2(+bar_width * 0.5, +bar_height * 0.5);
    p3 = bar_middle + Vec2(-bar_width * 0.5, +bar_height * 0.5);

    glColor3f(0.1f, 0.1f, 0.2f);

    glBegin(GL_QUADS);
    glVertex2fv(p0.m_v);
    glVertex2fv(p1.m_v);
    glVertex2fv(p2.m_v);
    glVertex2fv(p3.m_v);

    float t = (the_time - fly->stew_time_begin) / (fly->stew_time_end - fly->stew_time_begin);

    Vec2 p4 = p0 + t * (p1 - p0);
    Vec2 p5 = p3 + t * (p2 - p3);
    
    glColor3f(0.18f, 0.18f, 0.8f);
    glVertex2fv(p0.m_v);
    glVertex2fv(p4.m_v);
    glVertex2fv(p5.m_v);
    glVertex2fv(p3.m_v);
    glEnd();
}

void draw_fly(Fly *fly) {
    bool got_bitmap = false;

    switch (fly->motion_mode) {
    case FLY_FLYING:
        glColor3f(1.0f, 1.0f, 1.0f);
        break;
    case FLY_STUCK:
        glColor3f(1.0f, 1.0f, 1.0f);
        break;
    case FLY_STEWING: {
        float s = 0.7f;
        glColor3f(0.7f, 0.7f, 0.7f);
        glBindTexture(GL_TEXTURE_2D, fly_cocoon_bitmap);
        got_bitmap = true;
        break;
    }
    case FLY_DONE: {
        float period = 0.7f;
        float throb = cos(2 * M_PI * (the_time / period));
        const float THROB_MAGNITUDE = 0.35f;
        float s = (1.0f - THROB_MAGNITUDE) + THROB_MAGNITUDE * throb;
        glColor3f(s, s, s);
        glBindTexture(GL_TEXTURE_2D, fly_cocoon_bitmap);
        got_bitmap = true;
        break;
    }
    }

    if (!got_bitmap) {
        int frame = get_frame_index(fly->spawn_time) % NUM_FLY_ANIMATIONS;
        glBindTexture(GL_TEXTURE_2D, fly_animations[frame]);
    }

    draw_entity_quad(fly, FLY_RADIUS * 1.5f);
    if (fly->motion_mode == FLY_STEWING) {
        draw_fly_timer(fly);
    }
}

void draw_spider(Spider *spider) {
    glColor3f(1, 1, 1);
    switch (spider->motion_mode) {
    case MOTION_MODE_RESPAWNING: {
        float time = the_time - spider->respawn_time;
        int part = time / RESPAWN_BLINK_TIME;
        if (part & 1) return;  // Don't draw!
        glBindTexture(GL_TEXTURE_2D, animation_sets[spider->player_number].falling);
        break;
    }
    case MOTION_MODE_WALKING:
    default: {
        int frame = get_frame_index() % NUM_WALKING_ANIMATIONS;
        float len = spider->LeftStick.len();
        if (len < JOYSTICK_LEN_TO_MOVE) frame = 0;
        glBindTexture(GL_TEXTURE_2D, animation_sets[spider->player_number].walk_bitmaps[frame]);
        break;
    }
    case MOTION_MODE_CLENCHING:
        glBindTexture(GL_TEXTURE_2D, animation_sets[spider->player_number].clenching);
        break;
    case MOTION_MODE_FALLING:
        glBindTexture(GL_TEXTURE_2D, animation_sets[spider->player_number].falling);
        break;
    }

    draw_entity_quad(spider, SPIDER_RADIUS * 1.5f);
}

void draw_world() {
    glLoadIdentity();
    glRotated(180.0*(-CameraAngleRadians/M_PI),0,0,1);
    glTranslatef(-CameraX,-CameraY,-CameraZ);

    glDisable(GL_DEPTH_TEST);

    if (draw_control_lattice) {
        draw_control_lattice_stuff();
    }

    int i;
    glBegin(GL_LINES);
    for (i = 0; i < web_segments.items; i++) {
        Web_Segment *segment = web_segments[i];

        Vec3 color_a = get_wetness_color(segment->player_number, segment->fragment_a);
        Vec3 color_b = get_wetness_color(segment->player_number, segment->fragment_b);
        
        Vec2 p1, p2;
        segment->get_endpoints(&p1, &p2);

        glColor3fv(color_a.m_v);
        glVertex2fv(p1.m_v);
        glColor3fv(color_b.m_v);
        glVertex2fv(p2.m_v);
    }
    glEnd();

    Auto_Array <Spider *> spiders_to_draw;
    Auto_Array <Fly *> free_flies_to_draw;

    for (i = 0; i < entities.items; i++) {
        Entity *e = entities[i];
        switch (e->type) {
        case ENTITY_TYPE_WEB_FRAGMENT:
            if (draw_web_fragment_nodes) {
                glPointSize(20.0f);
                glDisable(GL_TEXTURE_2D);
                glColor3f(1.0f, 0.0f, 1.0f);
                draw_point(e->rb.x);
            }
            break;
        case ENTITY_TYPE_FLY: {
            Fly *fly = static_cast <Fly *>(e);
            if (fly->motion_mode == FLY_FLYING) {
                free_flies_to_draw.add(fly);
            } else {
                draw_fly(fly);
            }
            break;
        }
        case ENTITY_TYPE_SPIDER: {
            Spider *spider = (Spider *)e;
            spiders_to_draw.add(spider);
            break;
        }
        }
    }

    // Quirky drawing order stuff here (should have used the z buffer
    // I guess!)

    // Draw all the spiders
    for (i = 0; i < spiders_to_draw.items; i++) {
        draw_spider(spiders_to_draw[i]);
    }

    for (i = 0; i < free_flies_to_draw.items; i++) {
        draw_fly(free_flies_to_draw[i]);
    }

    // Draw any flies that are free (they go over spiders)
}

void think_about_flies() {
    if (the_time > the_time_for_next_fly) {
        // Roll up a time for the next next fly.
        float delay = RandomInRange(FLY_TIMER);
        the_time_for_next_fly = the_time + delay;
    } else {
        return;
    }

    Fly *fly = new Fly();
    entities.add(fly);
    fly->yes_antigravity();

    float y = random_in_range(Y_LOW, Y_HIGH);
    int n = random_integer();

    float x;
    float x_speed_sign;
    if (n & 1) {
        // Fly is on the right, going left...
        x = FLY_X_RIGHT;
        x_speed_sign = -1.0f;
    } else {
        // Fly is on the left, going right...
        x = FLY_X_LEFT;
        x_speed_sign = +1.0f;
    }

    float speed = RandomInRange(FLY_SPEED);
    Vec2 position(x, y);
    fly->set_position(position);
    fly->spawn_position = position;
    fly->rb.v = Vec2(speed * x_speed_sign, 0);
    fly->rb.update_derived_state();

    fly->amplitude1 = RandomInRange(FLY_AMPLITUDE1);
    fly->amplitude2 = RandomInRange(FLY_AMPLITUDE2);
    fly->period1 = RandomInRange(FLY_PERIOD1);
    fly->period2 = RandomInRange(FLY_PERIOD2);
    fly->motion_mode = FLY_FLYING;
    int sound_index = random_integer() % 2;
    char *sound_name;
    if (sound_index == 0) {
        sound_name = "content/sounds/fly_good_1.wav";
    } else {
        sound_name = "content/sounds/fly_good_2.wav";
    }

    zsoundPlay(sound_name);
}

void draw_player_score(int index, float x, float y) {
    Vec3 c = team_colors_wet[index];
    glColor4f(c.x(), c.y(), c.z(), 1.0f);

    char buf[100];
    int score = player_scores[index];
    sprintf(buf, "%d", score);

    // @HackTextConstant
    float offset = -0.25f * GetTextWidth(&big_font, buf);
    x += offset;

    DrawString(&big_font, x, y, buf);
}

bool point_within_safe_region(Safe_Region *region, Vec2 pos) {
    float x = pos.x();
    float y = pos.y();

    if (x < region->x0.x()) return false;
    if (x > region->x1.x()) return false;
    if (y < region->x0.y()) return false;
    if (y > region->x1.y()) return false;

    return true;
}

bool point_within_safe_region(Vec2 pos) {
    int i;
    for (i = 0; i < safe_regions.items; i++) {
        Safe_Region *region = safe_regions[i];
        if (point_within_safe_region(region, pos)) return true;
    }

    return false;
}

void draw_safe_regions() {
    if (!should_draw_safe_regions) return;
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    int i;
    for (i = 0; i < safe_regions.items; i++) {
        Safe_Region *region = safe_regions[i];
        glColor4f(0.5f, 0.5f, 0.5f, 0.5f);
        glBegin(GL_QUADS);
        glVertex2f(region->x0.x(), region->x0.y());
        glVertex2f(region->x1.x(), region->x0.y());
        glVertex2f(region->x1.x(), region->x1.y());
        glVertex2f(region->x0.x(), region->x1.y());
        glEnd();
    }

    glDisable(GL_BLEND);
}

void draw_hud() {
/*
    char buf[100];
    Vec2 wsm = WindowFromWorldCoords(world_mouse);
    sprintf(buf,"wm: %5.1f, %5.1f    sm: %5.1f, %5.1f   wsm: %5.1f, %5.1f",
            world_mouse.x(),world_mouse.y(),screen_mouse.x(),screen_mouse.y(),wsm.x(),wsm.y());
    DrawString(50,50,buf);
*/

    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    draw_player_score(1, WindowWidth * 0.11f, WindowHeight * 0.9f);
    draw_player_score(2, WindowWidth * 0.90f, WindowHeight * 0.9f);


    // Draw the score notes...
    int i;
    for (i = 0; i < score_notes.items; i++) {
        Score_Note *note = score_notes[i];

        float x = WindowWidth * note->position.x();
        float y = WindowHeight * note->position.y();
        
        Vec3 c = note->color;
        float a = note->alpha;
        glColor4f(c.x(), c.y(), c.z(), a);

        DrawString(&small_font, x, y, note->text);

        note->position += the_dt * note->velocity;
        note->alpha += note->dalpha_dt * the_dt;

        if (note->alpha <= 0) {
            // Kill this guy!
            score_notes[i] = score_notes[score_notes.items - 1];
            score_notes.items--;
            i--;
            delete note;
        }
    }

    glDisable(GL_BLEND);

    draw_safe_regions();

    if (the_time < DAYTIME_TOTAL) return;
    char buf[100];

    if (!winner_chosen) {
        winner_chosen = true;
        the_winner = 0;
        if (player_scores[1] > player_scores[2]) the_winner = 1;
        if (player_scores[2] > player_scores[1]) the_winner = 2;
    }

    float k;
    switch (the_winner) {
    case 0:
        sprintf(buf, " Tie Game!");
        k = -0.20f;
        break;
    case 1:
        sprintf(buf, "Green Wins!");
        k = -0.20f;
        break;
    case 2:
        sprintf(buf, " Red Wins!");
        k = -0.20f;
        break;
    }

    Vec3 color = team_colors_wet[the_winner];
    glColor3fv(color.m_v);

    float x = WindowWidth * 0.5f;
    float y = WindowHeight * 0.65f;
    float offset = k * GetTextWidth(&big_font, buf);

    x += offset;
    DrawString(&big_font, x, y, buf);
}

void draw_background() {
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();

    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
//    glOrtho(-1, 1, -1, 1, 0, 1);

    glBindTexture(GL_TEXTURE_2D, bitmap_background);
    glDisable(GL_DEPTH_TEST);
    glEnable(GL_TEXTURE_2D);
    glDisable(GL_CULL_FACE);
    glColor3f(1, 1, 1);
    float z = -0.5f;

    float yscale = -1.0f;   // .tga files come out upside down!

    glBegin(GL_QUADS);
    glTexCoord2f(0, 0);
    glVertex3f(-1, +1 * yscale, z);
    glTexCoord2f(1, 0);
    glVertex3f(+1, +1 * yscale, z);
    glTexCoord2f(1, 1);
    glVertex3f(+1, -1 * yscale, z);
    glTexCoord2f(0, 1);
    glVertex3f(-1, -1 * yscale, z);
    glEnd();

    //
    // Draw timer bar...
    //

    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glBindTexture(GL_TEXTURE_2D, bitmap_timer_bar);

    if (timer_bar_height == 0) timer_bar_height = 1;
    if (timer_bar_width == 0) timer_bar_width = 1;
    float aspect = (float)timer_bar_width / (float)timer_bar_height;
    float w = (timer_bar_width / 1600.0f);
    float h = 2 * (w / aspect);
    float yy0 = 1 - h;
    float yy1 = 1;
       

    // Draw juice bar
    float bar_x0 = -w + w * .45;
    float bar_x1 = -bar_x0;
    float bar_y1 = 1.0f;
    float bar_y0 = yy0 + 0.75f * (yy1 - yy0);

    float t = the_time / DAYTIME_TOTAL;
    if (t > 1.0f) t = 1.0f;

    float bar_x2 = bar_x0 + t * (bar_x1 - bar_x0);
    glDisable(GL_TEXTURE_2D);
    glBegin(GL_QUADS);
    glColor4f(1, 1, 0, 1.0f);
    glVertex3f(bar_x0, bar_y0, z);
    glVertex3f(bar_x2, bar_y0, z);
    glVertex3f(bar_x2, bar_y1, z);
    glVertex3f(bar_x0, bar_y1, z);
    glEnd();



    glColor4f(1, 1, 1, 1);
    glEnable(GL_TEXTURE_2D);
    glBegin(GL_QUADS);
    
    // Draw over-bitmap
    glTexCoord2f(0, 0);
    glVertex3f(-w, yy1, z);
    glTexCoord2f(1, 0);
    glVertex3f(+w, yy1, z);
    glTexCoord2f(1, 1);
    glVertex3f(+w, yy0, z);
    glTexCoord2f(0, 1);
    glVertex3f(-w, yy0, z);
    
    glEnd();

    glDisable(GL_BLEND);
    


    // Clean up...
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();

    glMatrixMode(GL_PROJECTION);
    glPopMatrix();

    glMatrixMode(GL_MODELVIEW);

    glDisable(GL_TEXTURE_2D);
}

void Update() {
    the_dt = 1.0f / GetFrameRate();
    the_time += the_dt;

	ps2controller.sample();

    think_about_flies();

    Auto_Array <Entity *> entities_to_delete;

    int i;
    for (i = 0; i < entities.items; i++) { 
        Entity *e = entities[i];
        if (e->type == ENTITY_TYPE_SPIDER) {
            Spider *spider = static_cast <Spider *>(e);
            spider->update();
        } else if (e->type == ENTITY_TYPE_WEB_FRAGMENT) {
            Web_Fragment *frag = static_cast <Web_Fragment *>(e);
            frag->wetness -= WETNESS_LOSS_PER_SECOND * the_dt;
            if (frag->wetness < 0) frag->wetness = 0;
        } else if (e->type == ENTITY_TYPE_FLY) {
            Fly *fly = static_cast <Fly *>(e);
            fly->update();

            // Kill the fly if he's far...
            float dist = (fly->rb.x - fly->spawn_position).len();
            if (dist > FLY_X_RIGHT - FLY_X_LEFT) { 
                entities_to_delete.add(fly);
            }
        }

        if (e->rb.x.y() < Y_OUT_OF_BOUNDS) {
            // @Incomplete:  Kill non-spider entities
            if (e->type == ENTITY_TYPE_SPIDER) {
                Spider *spider = static_cast <Spider *>(e);
                spider->respawn();
                if (spider->player_number == 1) {
                    play_player_sound("spawn_2");
                } else {
                    play_player_sound("spawn_3");
                }
                Score_Note *note = add_score(spider, spider->rb.x, -2, 0.2f);
            }
        }
    }

    for (i = 0; i < entities_to_delete.items; i++) {
        Entity *to_delete = entities_to_delete[i];
        entities.remove(to_delete);
        delete to_delete;
    }

    int const NumberOfSimSteps = 1;
    for(int StepCounter = 0;StepCounter < NumberOfSimSteps;++StepCounter) {
        // step as many times as you like
        simulator.step(1/(NumberOfSimSteps*GetFrameRate()));
        // do any game stuff you want here (like per-step collision response, etc.)
    }
    // now wait for the rest of the time so we're consistent on fast machines
    BusyWait(GetFrameRate());

    draw_background();

    draw_world();
    draw_hud();

    SwapBuffers(WindowDC);
}


LONG FAR PASCAL AppWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
    switch (msg)
    {
        // keyboard
        case WM_CHAR:
            break;
         
        case WM_KEYDOWN: {
            if (wParam == VK_ESCAPE) {
                AppQuit = true;
            } else if (wParam == VK_BACK) {
                delete_anchor();
            } else if (wParam == VK_F1) {
                draw_control_lattice = !draw_control_lattice;
            } else if (wParam == VK_F2) {
                draw_web_fragment_nodes = !draw_web_fragment_nodes;
            } else if (wParam == VK_F3) {
                should_draw_safe_regions = !should_draw_safe_regions;
            } else {
                handle_keydown(wParam);
            }
            break;
        }
        case WM_SYSKEYDOWN:
        case WM_SYSKEYUP:
        case WM_KEYUP:
            break;

        case WM_LBUTTONDOWN:
            left_button_down();
            break;
        case WM_LBUTTONUP:
            break;
        case WM_MBUTTONDOWN:
            break;
        case WM_MBUTTONUP:
            break;
        case WM_RBUTTONDOWN:
            right_button_down();
            break;
        case WM_RBUTTONUP:
            break;

        case WM_MOUSEMOVE: {
            screen_mouse = Vec2(float(GET_X_LPARAM(lParam)),float(GET_Y_LPARAM(lParam)));
            world_mouse = WorldFromWindowCoords(screen_mouse);
            break;
        }

         
            /**************** below is stuff you probably don't care about ****************/
         
        case WM_DESTROY: {
            PostQuitMessage(0);
            break;
        }
        case WM_PAINT: {
            PAINTSTRUCT ps;
            BeginPaint(hwnd,&ps);
            Update();
            EndPaint(hwnd,&ps);
            return 0L;
        }
        case WM_SIZE: {
            Resize(LOWORD(lParam),HIWORD(lParam));
            break;
        }
    }
    return (LONG)DefWindowProc(hwnd,msg,(LONG)wParam,(LONG)lParam);
}

/********************************** Resize **********************************/
/* called on WM_SIZE, and at the bottom of initialize                       */
void Resize( int w, int h )
{
    // compute our frustrum planes, the x,y plane values are on the near clip plane
    WindowWidth = w;
    WindowHeight = h;
    AspectRatio = float(w)/float(h);
    float ymax = ZNear * float(tan(FOVY/2.0));
    float ymin = -ymax;
    float xmin = AspectRatio * ymin;
    float xmax = AspectRatio * ymax;
   
    // load the viewport and projection matrix, gl stuff
    glViewport(0,0,w,h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    // gluPerspective doesn't set the near plane as the projection
    // plane, so you can't do good math, so do it ourselves
    glFrustum(xmin,xmax,ymin,ymax,ZNear,ZFar);
    glMatrixMode(GL_MODELVIEW);
}

/******************************* Uninitialize *******************************/
/* called before the graphics is destroyed, but the window is already toast */
void Uninitialize( void )
{
}

/********************************* WinMain **********************************/

int PASCAL WinMain(HINSTANCE hInst, HINSTANCE hPrev, LPSTR szCmdLine, int sw)
{
    // register and create our window
    WNDCLASS cls;
    if(!hPrev) {
        cls.hCursor        = LoadCursor(NULL,IDC_ARROW);
        cls.hIcon          = 0;
        cls.lpszMenuName   = 0;
        cls.lpszClassName  = AppName;
        cls.hbrBackground  = 0;
        cls.hInstance      = hInst;
        cls.style          = CS_VREDRAW | CS_HREDRAW | CS_DBLCLKS | CS_OWNDC;
        cls.lpfnWndProc    = (WNDPROC)AppWndProc;
        cls.cbWndExtra     = 0;
        cls.cbClsExtra     = 0;

        if (!RegisterClass(&cls))
            return FALSE;
    }

    DWORD Style = WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_CLIPSIBLINGS;
    RECT WindowRect = { 0, 0 };
    WindowRect.right = WindowWidth;
    WindowRect.bottom = WindowHeight;
    BOOL Menu = FALSE;

    AdjustWindowRect(&WindowRect,Style,Menu);
    
    WindowHandle = CreateWindow(AppName,AppName,Style,
                                CW_USEDEFAULT,0,
                                WindowRect.right-WindowRect.left,
                                WindowRect.bottom-WindowRect.top,
                                0,0,hInst,0);

    // create our gl stuff
    WindowDC = GetDC(WindowHandle);
    PIXELFORMATDESCRIPTOR FormatDescriptor = {
        sizeof (PIXELFORMATDESCRIPTOR), 1,
        PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
        PFD_TYPE_RGBA, 32,   // 32bpp
        0,0, 0,0, 0,0, 0,0,
        0, 0,0,0,0,
        24, 8,               // depth, stencil
        0,
        PFD_MAIN_PLANE,
        0,
        0,0,0
    };
    int FormatIndex = ChoosePixelFormat(WindowDC,&FormatDescriptor);
    SetPixelFormat(WindowDC,FormatIndex,&FormatDescriptor);
    WindowRC = wglCreateContext(WindowDC);
    wglMakeCurrent(WindowDC,WindowRC);

    // okay, ready to go
   
    Initialize();    // call the app
   
    ShowWindow(WindowHandle,sw);
   
    // pump the message queue
    MSG msg;
    while(!AppQuit) {
        if(PeekMessage(&msg,0,0,0,PM_REMOVE)) {
            if(msg.message == WM_QUIT)
                break;
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        } else {
            Update();    // call the app
        }
    }

    Uninitialize();  // call the app
   
    // clean up gl stuff and exit
    wglMakeCurrent(0,0);
    wglDeleteContext(WindowRC);
    ReleaseDC(WindowHandle,WindowDC);
   
    return int(msg.wParam);
}

/********************** utilities that use our globals **********************/
Vec2 WorldFromWindowCoords( Vec2 screen )
{
    float xn = float(screen.x())/WindowWidth - 0.5f;
    float yn = float(WindowHeight-screen.y())/WindowHeight - 0.5f;
    float xc = float(xn*2.0*CameraZ*tan(FOVY/2)*AspectRatio);
    float yc = float(yn*2.0*CameraZ*tan(FOVY/2));
    return Vec2(CameraX,CameraY) + Matrix22::rotation(CameraAngleRadians) * Vec2(xc,yc);
}
Vec2 WindowFromWorldCoords( Vec2 world )
{
    Vec2 c = Matrix22::rotation(-CameraAngleRadians) * (world - Vec2(CameraX,CameraY));
    float xn = float(c.x()/(2.0*CameraZ*tan(FOVY/2)*AspectRatio));
    float yn = float(c.y()/(2.0*CameraZ*tan(FOVY/2)));
    float xs = WindowWidth*(xn + 0.5f);
    float ys = WindowHeight - WindowHeight*(yn + 0.5f);
    return Vec2(xs,ys);
}
